/*1282:*/
#line 14824 "./marpa.w"

/*1278:*/
#line 14796 "./marpa.w"

/*
 * Copyright 2012 Jeffrey Kegler
 * This file is part of Marpa::R2.  Marpa::R2 is free software: you can
 * redistribute it and/or modify it under the terms of the GNU Lesser
 * General Public License as published by the Free Software Foundation,
 * either version 3 of the License, or (at your option) any later version.
 *
 * Marpa::R2 is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser
 * General Public License along with Marpa::R2.  If not, see
 * http://www.gnu.org/licenses/.
 */
/*
 * DO NOT EDIT DIRECTLY
 * This file is written by ctangle
 * It is not intended to be modified directly
 */

/*:1278*/
#line 14825 "./marpa.w"


#ifndef __MARPA_H__
#define __MARPA_H__ 
#include "marpa_config.h"

/*37:*/
#line 578 "./marpa.w"

extern const unsigned int marpa_major_version;
extern const unsigned int marpa_minor_version;
extern const unsigned int marpa_micro_version;
extern const unsigned int marpa_interface_age;
extern const unsigned int marpa_binary_age;
#define MARPA_CHECK_VERSION(major,minor,micro)  \
     (MARPA_MAJOR_VERSION >  (major) \
         || (MARPA_MAJOR_VERSION == (major) && MARPA_MINOR_VERSION >  (minor)) \
         || (MARPA_MAJOR_VERSION == (major) && MARPA_MINOR_VERSION == (minor) \
          && MARPA_MICRO_VERSION >= (micro)))

/*103:*/
#line 972 "./marpa.w"

#define marpa_g_event_value(event) \
    ((event)->t_value)
/*:103*//*258:*/
#line 2297 "./marpa.w"

#define MARPA_KEEP_SEPARATION  0x1
/*:258*//*262:*/
#line 2336 "./marpa.w"

#define MARPA_PROPER_SEPARATION  0x2
/*:262*//*1092:*/
#line 12539 "./marpa.w"

#define marpa_v_step_type(v) ((v)->t_step_type)
#define marpa_v_token(v) \
    ((v)->t_token_id)
#define marpa_v_symbol(v) marpa_v_token(v)
#define marpa_v_token_value(v) \
    ((v)->t_token_value)
#define marpa_v_rule(v) \
    ((v)->t_rule_id)
#define marpa_v_arg_0(v) \
    ((v)->t_arg_0)
#define marpa_v_arg_n(v) \
    ((v)->t_arg_n)
#define marpa_v_result(v) marpa_v_arg_0(v)
#define marpa_v_rule_start_es_id(v) ((v)->t_rule_start_es_id)
#define marpa_v_token_start_es_id(v) ((v)->t_token_start_es_id)
#define marpa_v_es_id(v) ((v)->t_es_id)

/*:1092*/
#line 590 "./marpa.w"

/*42:*/
#line 626 "./marpa.w"

struct marpa_g;
struct marpa_avl_table;
typedef struct marpa_g*Marpa_Grammar;
/*:42*//*563:*/
#line 6108 "./marpa.w"

struct marpa_r;
typedef struct marpa_r*Marpa_Recognizer;
typedef Marpa_Recognizer Marpa_Recce;
/*:563*//*963:*/
#line 11042 "./marpa.w"

struct marpa_bocage;
typedef struct marpa_bocage*Marpa_Bocage;
/*:963*//*1005:*/
#line 11469 "./marpa.w"

struct marpa_order;
typedef struct marpa_order*Marpa_Order;
/*:1005*//*1006:*/
#line 11472 "./marpa.w"

typedef Marpa_Order ORDER;
/*:1006*//*1039:*/
#line 11917 "./marpa.w"

struct marpa_tree;
typedef struct marpa_tree*Marpa_Tree;
/*:1039*//*1087:*/
#line 12497 "./marpa.w"

struct marpa_value;
typedef struct marpa_value*Marpa_Value;
/*:1087*/
#line 591 "./marpa.w"

/*87:*/
#line 888 "./marpa.w"

typedef int Marpa_Rank;
/*:87*//*102:*/
#line 969 "./marpa.w"

struct marpa_event;
typedef int Marpa_Event_Type;
/*:102*//*123:*/
#line 1130 "./marpa.w"

typedef int Marpa_Error_Code;
/*:123*//*130:*/
#line 1185 "./marpa.w"

typedef int Marpa_Symbol_ID;
/*:130*//*184:*/
#line 1571 "./marpa.w"

typedef int Marpa_ISY_ID;
/*:184*//*216:*/
#line 1794 "./marpa.w"

typedef int Marpa_Rule_ID;
/*:216*//*288:*/
#line 2477 "./marpa.w"

typedef int Marpa_IRL_ID;
/*:288*//*410:*/
#line 4314 "./marpa.w"

typedef int Marpa_AHFA_Item_ID;
/*:410*//*450:*/
#line 4667 "./marpa.w"

typedef int Marpa_AHFA_State_ID;

/*:450*//*617:*/
#line 6470 "./marpa.w"
typedef int Marpa_Earleme;
/*:617*//*619:*/
#line 6474 "./marpa.w"
typedef int Marpa_Earley_Set_ID;
/*:619*//*643:*/
#line 6668 "./marpa.w"
typedef int Marpa_Earley_Item_ID;
/*:643*//*872:*/
#line 9735 "./marpa.w"

typedef int Marpa_Or_Node_ID;
/*:872*//*932:*/
#line 10609 "./marpa.w"

typedef int Marpa_And_Node_ID;
/*:932*//*1073:*/
#line 12358 "./marpa.w"

typedef int Marpa_Nook_ID;
/*:1073*//*1127:*/
#line 12869 "./marpa.w"

typedef int Marpa_Step_Type;
/*:1127*//*1253:*/
#line 14496 "./marpa.w"

typedef const char*Marpa_Message_ID;

/*:1253*/
#line 592 "./marpa.w"

/*39:*/
#line 597 "./marpa.w"

struct marpa_config{
int t_is_ok;
Marpa_Error_Code t_error;
const char*t_error_string;
};
typedef struct marpa_config Marpa_Config;

/*:39*//*104:*/
#line 975 "./marpa.w"

struct marpa_event{
Marpa_Event_Type t_type;
int t_value;
};
typedef struct marpa_event Marpa_Event;
/*:104*//*952:*/
#line 10810 "./marpa.w"

struct marpa_progress_item{
Marpa_Rule_ID t_rule_id;
int t_position;
int t_origin;
};

/*:952*//*1091:*/
#line 12527 "./marpa.w"

struct marpa_value{
Marpa_Step_Type t_step_type;
Marpa_Symbol_ID t_token_id;
int t_token_value;
Marpa_Rule_ID t_rule_id;
int t_arg_0;
int t_arg_n;
Marpa_Earley_Set_ID t_token_start_es_id;
Marpa_Earley_Set_ID t_rule_start_es_id;
Marpa_Earley_Set_ID t_es_id;
};
/*:1091*/
#line 593 "./marpa.w"

/*1259:*/
#line 14548 "./marpa.w"

void marpa_debug_handler_set(int(*debug_handler)(const char*,...));
/*:1259*//*1261:*/
#line 14556 "./marpa.w"

void marpa_debug_level_set(int level);
/*:1261*/
#line 594 "./marpa.w"


/*:37*/
#line 14831 "./marpa.w"


#include "marpa_api.h"
#endif 

/*:1282*/
